#! /usr/bin/perl -w
use strict;
use Cwd;
my $date=0;
my $datef="";
my $current_line=0;
my $index=0;
my $n=0;
my $param=0;
my $r1=0;
my $s=0;
my $i=0;
my $j=0;
my $k=0;
my $cmd=0;
my $start=0;
my $jpg=0;
my @s="";

$date=localtime();
@s=split(/\s+/, $date);
$datef=$s[0];
for ($i=1;$i<@s-1;$i++) {
	$datef=$datef."_".$s[$i];
}
system("mkdir $datef");
chdir $datef;
system("cp ../*pl ./");
system("cp ../*r ./");


##########################################
##########################################
#paired end NextSeq sequencing
if ($ARGV[0] eq "nextseq_paired_end") {

	open (INSTREAM, "$ARGV[1]") or die "Couldn't open $ARGV[1]\n";
	open (INSTREAM1, "$ARGV[2]") or die "Couldn't open $ARGV[2]\n";
	open (OUT, ">T8_1.fq") or die "can not open file: T8_1.fq\n";
	open (OUT1, ">T8_2.fq") or die "can not open file: T8_2.fq\n";

#downsample to T8
	while ($current_line = <INSTREAM>) {
		chomp ($current_line);
		if ($current_line=~/\@/) {
			$index=0;
			@s=split(/\:/, $current_line);
			if ($s[2] =~ /8$/) {
				$index=100;
			}
		}

		if ($index==100) {
			print OUT "$current_line\n";
		}
	}


	while ($current_line = <INSTREAM1>) {
		chomp ($current_line);
		if ($current_line=~/\@/) {
			$index=0;
			@s=split(/\:/, $current_line);
			if ($s[2] =~ /8$/) {
				$index=100;
			}
		}

		if ($index==100) {
			print OUT1 "$current_line\n";
		}
	}


#retrieve the first 30bp of the sequencing reads and align them
	system("fastx_trimmer -l 30 -i T8_1.fq -Q33 >read1.fq");
	system("fastx_trimmer -l 30 -i T8_2.fq -Q33 >read2.fq");
	system("bowtie2 -x ../phiX -1 read1.fq -2 read2.fq -S align.sam");

#seperate phiX reas with no indels in the first 30 bp
	system("./MD.pl align.sam T8_tmp.sam");

#separate read1 from read2 and seperate forward reads from reverse reads
	system("head -2 align.sam >sam_header");
	system("cat sam_header T8_tmp.sam >T8.sam");
	system("samtools view -f 0x40 -S T8.sam >Read1.sam");
	system("cat sam_header Read1.sam >Read1_h.sam");
	system("samtools view -F 0x10 -S Read1_h.sam >phiX_Read1_f.sam");
	system("samtools view -f 0x10 -S Read1_h.sam >phiX_Read1_r.sam");
	system("samtools view -f 0x80 -S T8.sam >Read2.sam");
	system("cat sam_header Read2.sam >Read2_h.sam");
	system("samtools view -F 0x10 -S Read2_h.sam >phiX_Read2_f.sam");
	system("samtools view -f 0x10 -S Read2_h.sam >phiX_Read2_r.sam");

#seperate reads by camera
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera1_phiX_Read1_f 1");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera2_phiX_Read1_f 2");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera3_phiX_Read1_f 3");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera4_phiX_Read1_f 4");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera5_phiX_Read1_f 5");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera6_phiX_Read1_f 6");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera1_phiX_Read1_r 1");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera2_phiX_Read1_r 2");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera3_phiX_Read1_r 3");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera4_phiX_Read1_r 4");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera5_phiX_Read1_r 5");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera6_phiX_Read1_r 6");
	system("./camera_parsing_seqname.pl phiX_Read2_f.sam camera1_phiX_Read2_f 1");
	system("./camera_parsing_seqname.pl phiX_Read2_f.sam camera2_phiX_Read2_f 2");
	system("./camera_parsing_seqname.pl phiX_Read2_f.sam camera3_phiX_Read2_f 3");
	system("./camera_parsing_seqname.pl phiX_Read2_f.sam camera4_phiX_Read2_f 4");
	system("./camera_parsing_seqname.pl phiX_Read2_f.sam camera5_phiX_Read2_f 5");
	system("./camera_parsing_seqname.pl phiX_Read2_f.sam camera6_phiX_Read2_f 6");
	system("./camera_parsing_seqname.pl phiX_Read2_r.sam camera1_phiX_Read2_r 1");
	system("./camera_parsing_seqname.pl phiX_Read2_r.sam camera2_phiX_Read2_r 2");
	system("./camera_parsing_seqname.pl phiX_Read2_r.sam camera3_phiX_Read2_r 3");
	system("./camera_parsing_seqname.pl phiX_Read2_r.sam camera4_phiX_Read2_r 4");
	system("./camera_parsing_seqname.pl phiX_Read2_r.sam camera5_phiX_Read2_r 5");
	system("./camera_parsing_seqname.pl phiX_Read2_r.sam camera6_phiX_Read2_r 6");

#making sequence file of each camera, Read1/2, forward/reverse reads
	system("./mk_fa1.pl T8_1.fq camera1_phiX_Read1_f camera1_phiX_Read1_f_seq");
	system("./mk_fa1.pl T8_1.fq camera2_phiX_Read1_f camera2_phiX_Read1_f_seq");
	system("./mk_fa1.pl T8_1.fq camera3_phiX_Read1_f camera3_phiX_Read1_f_seq");
	system("./mk_fa1.pl T8_1.fq camera4_phiX_Read1_f camera4_phiX_Read1_f_seq");
	system("./mk_fa1.pl T8_1.fq camera5_phiX_Read1_f camera5_phiX_Read1_f_seq");
	system("./mk_fa1.pl T8_1.fq camera6_phiX_Read1_f camera6_phiX_Read1_f_seq");
	system("./mk_fa1r.pl T8_1.fq camera1_phiX_Read1_r camera1_phiX_Read1_r_seq");
	system("./mk_fa1r.pl T8_1.fq camera2_phiX_Read1_r camera2_phiX_Read1_r_seq");
	system("./mk_fa1r.pl T8_1.fq camera3_phiX_Read1_r camera3_phiX_Read1_r_seq");
	system("./mk_fa1r.pl T8_1.fq camera4_phiX_Read1_r camera4_phiX_Read1_r_seq");
	system("./mk_fa1r.pl T8_1.fq camera5_phiX_Read1_r camera5_phiX_Read1_r_seq");
	system("./mk_fa1r.pl T8_1.fq camera6_phiX_Read1_r camera6_phiX_Read1_r_seq");
	system("./mk_fa2.pl T8_2.fq camera1_phiX_Read2_f camera1_phiX_Read2_f_seq");
	system("./mk_fa2.pl T8_2.fq camera2_phiX_Read2_f camera2_phiX_Read2_f_seq");
	system("./mk_fa2.pl T8_2.fq camera3_phiX_Read2_f camera3_phiX_Read2_f_seq");
	system("./mk_fa2.pl T8_2.fq camera4_phiX_Read2_f camera4_phiX_Read2_f_seq");
	system("./mk_fa2.pl T8_2.fq camera5_phiX_Read2_f camera5_phiX_Read2_f_seq");
	system("./mk_fa2.pl T8_2.fq camera6_phiX_Read2_f camera6_phiX_Read2_f_seq");
	system("./mk_fa2r.pl T8_2.fq camera1_phiX_Read2_r camera1_phiX_Read2_r_seq");
	system("./mk_fa2r.pl T8_2.fq camera2_phiX_Read2_r camera2_phiX_Read2_r_seq");
	system("./mk_fa2r.pl T8_2.fq camera3_phiX_Read2_r camera3_phiX_Read2_r_seq");
	system("./mk_fa2r.pl T8_2.fq camera4_phiX_Read2_r camera4_phiX_Read2_r_seq");
	system("./mk_fa2r.pl T8_2.fq camera5_phiX_Read2_r camera5_phiX_Read2_r_seq");
	system("./mk_fa2r.pl T8_2.fq camera6_phiX_Read2_r camera6_phiX_Read2_r_seq");


#making bed file to retrieve reference sequence
	system("./bed.pl camera1_phiX_Read1_f_seq phiX_Read1_f.sam camera1_phiX_Read1_f.bed");
	system("./bed.pl camera2_phiX_Read1_f_seq phiX_Read1_f.sam camera2_phiX_Read1_f.bed");
	system("./bed.pl camera3_phiX_Read1_f_seq phiX_Read1_f.sam camera3_phiX_Read1_f.bed");
	system("./bed.pl camera4_phiX_Read1_f_seq phiX_Read1_f.sam camera4_phiX_Read1_f.bed");
	system("./bed.pl camera5_phiX_Read1_f_seq phiX_Read1_f.sam camera5_phiX_Read1_f.bed");
	system("./bed.pl camera6_phiX_Read1_f_seq phiX_Read1_f.sam camera6_phiX_Read1_f.bed");
	system("./bed_r.pl camera1_phiX_Read1_r_seq phiX_Read1_r.sam camera1_phiX_Read1_r.bed");
	system("./bed_r.pl camera2_phiX_Read1_r_seq phiX_Read1_r.sam camera2_phiX_Read1_r.bed");
	system("./bed_r.pl camera3_phiX_Read1_r_seq phiX_Read1_r.sam camera3_phiX_Read1_r.bed");
	system("./bed_r.pl camera4_phiX_Read1_r_seq phiX_Read1_r.sam camera4_phiX_Read1_r.bed");
	system("./bed_r.pl camera5_phiX_Read1_r_seq phiX_Read1_r.sam camera5_phiX_Read1_r.bed");
	system("./bed_r.pl camera6_phiX_Read1_r_seq phiX_Read1_r.sam camera6_phiX_Read1_r.bed");
	system("./bed.pl camera1_phiX_Read2_f_seq phiX_Read2_f.sam camera1_phiX_Read2_f.bed");
	system("./bed.pl camera2_phiX_Read2_f_seq phiX_Read2_f.sam camera2_phiX_Read2_f.bed");
	system("./bed.pl camera3_phiX_Read2_f_seq phiX_Read2_f.sam camera3_phiX_Read2_f.bed");
	system("./bed.pl camera4_phiX_Read2_f_seq phiX_Read2_f.sam camera4_phiX_Read2_f.bed");
	system("./bed.pl camera5_phiX_Read2_f_seq phiX_Read2_f.sam camera5_phiX_Read2_f.bed");
	system("./bed.pl camera6_phiX_Read2_f_seq phiX_Read2_f.sam camera6_phiX_Read2_f.bed");
	system("./bed_r.pl camera1_phiX_Read2_r_seq phiX_Read2_r.sam camera1_phiX_Read2_r.bed");
	system("./bed_r.pl camera2_phiX_Read2_r_seq phiX_Read2_r.sam camera2_phiX_Read2_r.bed");
	system("./bed_r.pl camera3_phiX_Read2_r_seq phiX_Read2_r.sam camera3_phiX_Read2_r.bed");
	system("./bed_r.pl camera4_phiX_Read2_r_seq phiX_Read2_r.sam camera4_phiX_Read2_r.bed");
	system("./bed_r.pl camera5_phiX_Read2_r_seq phiX_Read2_r.sam camera5_phiX_Read2_r.bed");
	system("./bed_r.pl camera6_phiX_Read2_r_seq phiX_Read2_r.sam camera6_phiX_Read2_r.bed");


#get reference fasta files from bed
	system("bedtools getfasta -fi ../phiX.fa -bed camera1_phiX_Read1_f.bed -fo camera1_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera2_phiX_Read1_f.bed -fo camera2_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera3_phiX_Read1_f.bed -fo camera3_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera4_phiX_Read1_f.bed -fo camera4_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera5_phiX_Read1_f.bed -fo camera5_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera6_phiX_Read1_f.bed -fo camera6_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera1_phiX_Read1_r.bed -fo camera1_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera2_phiX_Read1_r.bed -fo camera2_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera3_phiX_Read1_r.bed -fo camera3_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera4_phiX_Read1_r.bed -fo camera4_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera5_phiX_Read1_r.bed -fo camera5_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera6_phiX_Read1_r.bed -fo camera6_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera1_phiX_Read2_f.bed -fo camera1_phiX_Read2_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera2_phiX_Read2_f.bed -fo camera2_phiX_Read2_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera3_phiX_Read2_f.bed -fo camera3_phiX_Read2_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera4_phiX_Read2_f.bed -fo camera4_phiX_Read2_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera5_phiX_Read2_f.bed -fo camera5_phiX_Read2_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera6_phiX_Read2_f.bed -fo camera6_phiX_Read2_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera1_phiX_Read2_r.bed -fo camera1_phiX_Read2_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera2_phiX_Read2_r.bed -fo camera2_phiX_Read2_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera3_phiX_Read2_r.bed -fo camera3_phiX_Read2_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera4_phiX_Read2_r.bed -fo camera4_phiX_Read2_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera5_phiX_Read2_r.bed -fo camera5_phiX_Read2_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera6_phiX_Read2_r.bed -fo camera6_phiX_Read2_r_ref.fa -name");


#format reference fasta file to table file for merging with real sequencing data in next steps
	system("./format.pl camera1_phiX_Read1_f_ref.fa camera1_phiX_Read1_f_ref");
	system("./format.pl camera2_phiX_Read1_f_ref.fa camera2_phiX_Read1_f_ref");
	system("./format.pl camera3_phiX_Read1_f_ref.fa camera3_phiX_Read1_f_ref");
	system("./format.pl camera4_phiX_Read1_f_ref.fa camera4_phiX_Read1_f_ref");
	system("./format.pl camera5_phiX_Read1_f_ref.fa camera5_phiX_Read1_f_ref");
	system("./format.pl camera6_phiX_Read1_f_ref.fa camera6_phiX_Read1_f_ref");
	system("./format.pl camera1_phiX_Read1_r_ref.fa camera1_phiX_Read1_r_ref");
	system("./format.pl camera2_phiX_Read1_r_ref.fa camera2_phiX_Read1_r_ref");
	system("./format.pl camera3_phiX_Read1_r_ref.fa camera3_phiX_Read1_r_ref");
	system("./format.pl camera4_phiX_Read1_r_ref.fa camera4_phiX_Read1_r_ref");
	system("./format.pl camera5_phiX_Read1_r_ref.fa camera5_phiX_Read1_r_ref");
	system("./format.pl camera6_phiX_Read1_r_ref.fa camera6_phiX_Read1_r_ref");
	system("./format.pl camera1_phiX_Read2_f_ref.fa camera1_phiX_Read2_f_ref");
	system("./format.pl camera2_phiX_Read2_f_ref.fa camera2_phiX_Read2_f_ref");
	system("./format.pl camera3_phiX_Read2_f_ref.fa camera3_phiX_Read2_f_ref");
	system("./format.pl camera4_phiX_Read2_f_ref.fa camera4_phiX_Read2_f_ref");
	system("./format.pl camera5_phiX_Read2_f_ref.fa camera5_phiX_Read2_f_ref");
	system("./format.pl camera6_phiX_Read2_f_ref.fa camera6_phiX_Read2_f_ref");
	system("./format.pl camera1_phiX_Read2_r_ref.fa camera1_phiX_Read2_r_ref");
	system("./format.pl camera2_phiX_Read2_r_ref.fa camera2_phiX_Read2_r_ref");
	system("./format.pl camera3_phiX_Read2_r_ref.fa camera3_phiX_Read2_r_ref");
	system("./format.pl camera4_phiX_Read2_r_ref.fa camera4_phiX_Read2_r_ref");
	system("./format.pl camera5_phiX_Read2_r_ref.fa camera5_phiX_Read2_r_ref");
	system("./format.pl camera6_phiX_Read2_r_ref.fa camera6_phiX_Read2_r_ref");

#merging reference seq table with real sequencing data in next steps
	system("./overlaphash.pl camera1_phiX_Read1_f_ref camera1_phiX_Read1_f_seq camera1_phiX_Read1_f");
	system("./overlaphash.pl camera2_phiX_Read1_f_ref camera2_phiX_Read1_f_seq camera2_phiX_Read1_f");
	system("./overlaphash.pl camera3_phiX_Read1_f_ref camera3_phiX_Read1_f_seq camera3_phiX_Read1_f");
	system("./overlaphash.pl camera4_phiX_Read1_f_ref camera4_phiX_Read1_f_seq camera4_phiX_Read1_f");
	system("./overlaphash.pl camera5_phiX_Read1_f_ref camera5_phiX_Read1_f_seq camera5_phiX_Read1_f");
	system("./overlaphash.pl camera6_phiX_Read1_f_ref camera6_phiX_Read1_f_seq camera6_phiX_Read1_f");
	system("./overlaphash_r.pl camera1_phiX_Read1_r_ref camera1_phiX_Read1_r_seq camera1_phiX_Read1_r");
	system("./overlaphash_r.pl camera2_phiX_Read1_r_ref camera2_phiX_Read1_r_seq camera2_phiX_Read1_r");
	system("./overlaphash_r.pl camera3_phiX_Read1_r_ref camera3_phiX_Read1_r_seq camera3_phiX_Read1_r");
	system("./overlaphash_r.pl camera4_phiX_Read1_r_ref camera4_phiX_Read1_r_seq camera4_phiX_Read1_r");
	system("./overlaphash_r.pl camera5_phiX_Read1_r_ref camera5_phiX_Read1_r_seq camera5_phiX_Read1_r");
	system("./overlaphash_r.pl camera6_phiX_Read1_r_ref camera6_phiX_Read1_r_seq camera6_phiX_Read1_r");
	system("./overlaphash.pl camera1_phiX_Read2_f_ref camera1_phiX_Read2_f_seq camera1_phiX_Read2_f");
	system("./overlaphash.pl camera2_phiX_Read2_f_ref camera2_phiX_Read2_f_seq camera2_phiX_Read2_f");
	system("./overlaphash.pl camera3_phiX_Read2_f_ref camera3_phiX_Read2_f_seq camera3_phiX_Read2_f");
	system("./overlaphash.pl camera4_phiX_Read2_f_ref camera4_phiX_Read2_f_seq camera4_phiX_Read2_f");
	system("./overlaphash.pl camera5_phiX_Read2_f_ref camera5_phiX_Read2_f_seq camera5_phiX_Read2_f");
	system("./overlaphash.pl camera6_phiX_Read2_f_ref camera6_phiX_Read2_f_seq camera6_phiX_Read2_f");
	system("./overlaphash_r.pl camera1_phiX_Read2_r_ref camera1_phiX_Read2_r_seq camera1_phiX_Read2_r");
	system("./overlaphash_r.pl camera2_phiX_Read2_r_ref camera2_phiX_Read2_r_seq camera2_phiX_Read2_r");
	system("./overlaphash_r.pl camera3_phiX_Read2_r_ref camera3_phiX_Read2_r_seq camera3_phiX_Read2_r");
	system("./overlaphash_r.pl camera4_phiX_Read2_r_ref camera4_phiX_Read2_r_seq camera4_phiX_Read2_r");
	system("./overlaphash_r.pl camera5_phiX_Read2_r_ref camera5_phiX_Read2_r_seq camera5_phiX_Read2_r");
	system("./overlaphash_r.pl camera6_phiX_Read2_r_ref camera6_phiX_Read2_r_seq camera6_phiX_Read2_r");

#filter away sequences with indels defined as 3 continuous nt mismatching between ref and seq
	system("./filter_indel.pl camera1_phiX_Read1_f camera1_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera2_phiX_Read1_f camera2_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera3_phiX_Read1_f camera3_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera4_phiX_Read1_f camera4_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera5_phiX_Read1_f camera5_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera6_phiX_Read1_f camera6_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera1_phiX_Read1_r camera1_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera2_phiX_Read1_r camera2_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera3_phiX_Read1_r camera3_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera4_phiX_Read1_r camera4_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera5_phiX_Read1_r camera5_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera6_phiX_Read1_r camera6_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera1_phiX_Read2_f camera1_phiX_Read2_f_no_indel");
	system("./filter_indel.pl camera2_phiX_Read2_f camera2_phiX_Read2_f_no_indel");
	system("./filter_indel.pl camera3_phiX_Read2_f camera3_phiX_Read2_f_no_indel");
	system("./filter_indel.pl camera4_phiX_Read2_f camera4_phiX_Read2_f_no_indel");
	system("./filter_indel.pl camera5_phiX_Read2_f camera5_phiX_Read2_f_no_indel");
	system("./filter_indel.pl camera6_phiX_Read2_f camera6_phiX_Read2_f_no_indel");
	system("./filter_indel.pl camera1_phiX_Read2_r camera1_phiX_Read2_r_no_indel");
	system("./filter_indel.pl camera2_phiX_Read2_r camera2_phiX_Read2_r_no_indel");
	system("./filter_indel.pl camera3_phiX_Read2_r camera3_phiX_Read2_r_no_indel");
	system("./filter_indel.pl camera4_phiX_Read2_r camera4_phiX_Read2_r_no_indel");
	system("./filter_indel.pl camera5_phiX_Read2_r camera5_phiX_Read2_r_no_indel");
	system("./filter_indel.pl camera6_phiX_Read2_r camera6_phiX_Read2_r_no_indel");

#mismatch counting
	system("./mismatch_count_v4.pl camera1_phiX_Read1_f camera1_phiX_Read1_r camera1_Read1_mm size_r1_c1");
	system("./mismatch_count_v4.pl camera2_phiX_Read1_f camera2_phiX_Read1_r camera2_Read1_mm size_r1_c2");
	system("./mismatch_count_v4.pl camera3_phiX_Read1_f camera3_phiX_Read1_r camera3_Read1_mm size_r1_c3");
	system("./mismatch_count_v4.pl camera4_phiX_Read1_f camera4_phiX_Read1_r camera4_Read1_mm size_r1_c4");
	system("./mismatch_count_v4.pl camera5_phiX_Read1_f camera5_phiX_Read1_r camera5_Read1_mm size_r1_c5");
	system("./mismatch_count_v4.pl camera6_phiX_Read1_f camera6_phiX_Read1_r camera6_Read1_mm size_r1_c6");

	system("./mismatch_count_v4_r2.pl camera1_phiX_Read2_f camera1_phiX_Read2_r size_r1_c1 camera1_Read2_mm");
	system("./mismatch_count_v4_r2.pl camera2_phiX_Read2_f camera2_phiX_Read2_r size_r1_c2 camera2_Read2_mm");
	system("./mismatch_count_v4_r2.pl camera3_phiX_Read2_f camera3_phiX_Read2_r size_r1_c3 camera3_Read2_mm");
	system("./mismatch_count_v4_r2.pl camera4_phiX_Read2_f camera4_phiX_Read2_r size_r1_c4 camera4_Read2_mm");
	system("./mismatch_count_v4_r2.pl camera5_phiX_Read2_f camera5_phiX_Read2_r size_r1_c5 camera5_Read2_mm");
	system("./mismatch_count_v4_r2.pl camera6_phiX_Read2_f camera6_phiX_Read2_r size_r1_c6 camera6_Read2_mm");

	system("cat header camera1_Read1_mm camera1_Read2_mm  >camera1_mmh");
	system("cat header camera2_Read1_mm camera2_Read2_mm  >camera2_mmh");
	system("cat header camera3_Read1_mm camera3_Read2_mm  >camera3_mmh");
	system("cat header camera4_Read1_mm camera4_Read2_mm  >camera4_mmh");
	system("cat header camera5_Read1_mm camera5_Read2_mm  >camera5_mmh");
	system("cat header camera6_Read1_mm camera6_Read2_mm  >camera6_mmh");

#plotting
	system("R --slave --vanilla <plot.r");
}

#single end NextSeq sequencing
elsif ($ARGV[0] eq "nextseq_single_end") {

        open (INSTREAM, "$ARGV[1]") or die "Couldn't open $ARGV[1]\n";
        open (OUT, ">T8_1.fq") or die "can not open file: T8_1.fq\n";

#downsample to T8
        while ($current_line = <INSTREAM>) {
                chomp ($current_line);
                if ($current_line=~/\@/) {
                        $index=0;
                        @s=split(/\:/, $current_line);
                        if ($s[2] =~ /8$/) {
                                $index=100;
                        }
                }

                if ($index==100) {
                        print OUT "$current_line\n";
                }
        }


#retrieve the first 30bp of the sequencing reads and align them
	system("fastx_trimmer -l 30 -i T8_1.fq -Q33 >read1.fq");
	system("bowtie2 -x ../phiX -U read1.fq -S align.sam");

#seperate phiX reas with no indels in the first 30 bp
	system("./MD.pl align.sam T8_tmp.sam");

#seperate forward reads from reverse reads
	system("head -2 align.sam >sam_header");
	system("cat sam_header T8_tmp.sam >Read1_h.sam");
	system("samtools view -F 0x10 -S Read1_h.sam >phiX_Read1_f.sam");
	system("samtools view -f 0x10 -S Read1_h.sam >phiX_Read1_r.sam");

#seperate reads by camera
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera1_phiX_Read1_f 1");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera2_phiX_Read1_f 2");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera3_phiX_Read1_f 3");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera4_phiX_Read1_f 4");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera5_phiX_Read1_f 5");
	system("./camera_parsing_seqname.pl phiX_Read1_f.sam camera6_phiX_Read1_f 6");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera1_phiX_Read1_r 1");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera2_phiX_Read1_r 2");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera3_phiX_Read1_r 3");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera4_phiX_Read1_r 4");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera5_phiX_Read1_r 5");
	system("./camera_parsing_seqname.pl phiX_Read1_r.sam camera6_phiX_Read1_r 6");

#making sequence file of each camera, forward/reverse reads
	system("./mk_fa.pl T8_1.fq camera1_phiX_Read1_f camera1_phiX_Read1_f_seq");
	system("./mk_fa.pl T8_1.fq camera2_phiX_Read1_f camera2_phiX_Read1_f_seq");
	system("./mk_fa.pl T8_1.fq camera3_phiX_Read1_f camera3_phiX_Read1_f_seq");
	system("./mk_fa.pl T8_1.fq camera4_phiX_Read1_f camera4_phiX_Read1_f_seq");
	system("./mk_fa.pl T8_1.fq camera5_phiX_Read1_f camera5_phiX_Read1_f_seq");
	system("./mk_fa.pl T8_1.fq camera6_phiX_Read1_f camera6_phiX_Read1_f_seq");
	system("./mk_far.pl T8_1.fq camera1_phiX_Read1_r camera1_phiX_Read1_r_seq");
	system("./mk_far.pl T8_1.fq camera2_phiX_Read1_r camera2_phiX_Read1_r_seq");
	system("./mk_far.pl T8_1.fq camera3_phiX_Read1_r camera3_phiX_Read1_r_seq");
	system("./mk_far.pl T8_1.fq camera4_phiX_Read1_r camera4_phiX_Read1_r_seq");
	system("./mk_far.pl T8_1.fq camera5_phiX_Read1_r camera5_phiX_Read1_r_seq");
	system("./mk_far.pl T8_1.fq camera6_phiX_Read1_r camera6_phiX_Read1_r_seq");

#making bed file to retrieve reference sequence
	system("./bed_s.pl camera1_phiX_Read1_f_seq phiX_Read1_f.sam camera1_phiX_Read1_f.bed");
	system("./bed_s.pl camera2_phiX_Read1_f_seq phiX_Read1_f.sam camera2_phiX_Read1_f.bed");
	system("./bed_s.pl camera3_phiX_Read1_f_seq phiX_Read1_f.sam camera3_phiX_Read1_f.bed");
	system("./bed_s.pl camera4_phiX_Read1_f_seq phiX_Read1_f.sam camera4_phiX_Read1_f.bed");
	system("./bed_s.pl camera5_phiX_Read1_f_seq phiX_Read1_f.sam camera5_phiX_Read1_f.bed");
	system("./bed_s.pl camera6_phiX_Read1_f_seq phiX_Read1_f.sam camera6_phiX_Read1_f.bed");
	system("./bed_rs.pl camera1_phiX_Read1_r_seq phiX_Read1_r.sam camera1_phiX_Read1_r.bed");
	system("./bed_rs.pl camera2_phiX_Read1_r_seq phiX_Read1_r.sam camera2_phiX_Read1_r.bed");
	system("./bed_rs.pl camera3_phiX_Read1_r_seq phiX_Read1_r.sam camera3_phiX_Read1_r.bed");
	system("./bed_rs.pl camera4_phiX_Read1_r_seq phiX_Read1_r.sam camera4_phiX_Read1_r.bed");
	system("./bed_rs.pl camera5_phiX_Read1_r_seq phiX_Read1_r.sam camera5_phiX_Read1_r.bed");
	system("./bed_rs.pl camera6_phiX_Read1_r_seq phiX_Read1_r.sam camera6_phiX_Read1_r.bed");


#get reference fasta files from bed
	system("bedtools getfasta -fi ../phiX.fa -bed camera1_phiX_Read1_f.bed -fo camera1_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera2_phiX_Read1_f.bed -fo camera2_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera3_phiX_Read1_f.bed -fo camera3_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera4_phiX_Read1_f.bed -fo camera4_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera5_phiX_Read1_f.bed -fo camera5_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera6_phiX_Read1_f.bed -fo camera6_phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera1_phiX_Read1_r.bed -fo camera1_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera2_phiX_Read1_r.bed -fo camera2_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera3_phiX_Read1_r.bed -fo camera3_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera4_phiX_Read1_r.bed -fo camera4_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera5_phiX_Read1_r.bed -fo camera5_phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed camera6_phiX_Read1_r.bed -fo camera6_phiX_Read1_r_ref.fa -name");


#format reference fasta file to table file for merging with real sequencing data in next steps
	system("./format.pl camera1_phiX_Read1_f_ref.fa camera1_phiX_Read1_f_ref");
	system("./format.pl camera2_phiX_Read1_f_ref.fa camera2_phiX_Read1_f_ref");
	system("./format.pl camera3_phiX_Read1_f_ref.fa camera3_phiX_Read1_f_ref");
	system("./format.pl camera4_phiX_Read1_f_ref.fa camera4_phiX_Read1_f_ref");
	system("./format.pl camera5_phiX_Read1_f_ref.fa camera5_phiX_Read1_f_ref");
	system("./format.pl camera6_phiX_Read1_f_ref.fa camera6_phiX_Read1_f_ref");
	system("./format.pl camera1_phiX_Read1_r_ref.fa camera1_phiX_Read1_r_ref");
	system("./format.pl camera2_phiX_Read1_r_ref.fa camera2_phiX_Read1_r_ref");
	system("./format.pl camera3_phiX_Read1_r_ref.fa camera3_phiX_Read1_r_ref");
	system("./format.pl camera4_phiX_Read1_r_ref.fa camera4_phiX_Read1_r_ref");
	system("./format.pl camera5_phiX_Read1_r_ref.fa camera5_phiX_Read1_r_ref");
	system("./format.pl camera6_phiX_Read1_r_ref.fa camera6_phiX_Read1_r_ref");

#merging reference seq table with real sequencing data in next steps
	system("./overlaphash_s.pl camera1_phiX_Read1_f_ref camera1_phiX_Read1_f_seq camera1_phiX_Read1_f");
	system("./overlaphash_s.pl camera2_phiX_Read1_f_ref camera2_phiX_Read1_f_seq camera2_phiX_Read1_f");
	system("./overlaphash_s.pl camera3_phiX_Read1_f_ref camera3_phiX_Read1_f_seq camera3_phiX_Read1_f");
	system("./overlaphash_s.pl camera4_phiX_Read1_f_ref camera4_phiX_Read1_f_seq camera4_phiX_Read1_f");
	system("./overlaphash_s.pl camera5_phiX_Read1_f_ref camera5_phiX_Read1_f_seq camera5_phiX_Read1_f");
	system("./overlaphash_s.pl camera6_phiX_Read1_f_ref camera6_phiX_Read1_f_seq camera6_phiX_Read1_f");
	system("./overlaphash_rs.pl camera1_phiX_Read1_r_ref camera1_phiX_Read1_r_seq camera1_phiX_Read1_r");
	system("./overlaphash_rs.pl camera2_phiX_Read1_r_ref camera2_phiX_Read1_r_seq camera2_phiX_Read1_r");
	system("./overlaphash_rs.pl camera3_phiX_Read1_r_ref camera3_phiX_Read1_r_seq camera3_phiX_Read1_r");
	system("./overlaphash_rs.pl camera4_phiX_Read1_r_ref camera4_phiX_Read1_r_seq camera4_phiX_Read1_r");
	system("./overlaphash_rs.pl camera5_phiX_Read1_r_ref camera5_phiX_Read1_r_seq camera5_phiX_Read1_r");
	system("./overlaphash_rs.pl camera6_phiX_Read1_r_ref camera6_phiX_Read1_r_seq camera6_phiX_Read1_r");

#filter away sequences with indels defined as 3 continuous nt mismatching between ref and seq
	system("./filter_indel.pl camera1_phiX_Read1_f camera1_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera2_phiX_Read1_f camera2_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera3_phiX_Read1_f camera3_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera4_phiX_Read1_f camera4_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera5_phiX_Read1_f camera5_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera6_phiX_Read1_f camera6_phiX_Read1_f_no_indel");
	system("./filter_indel.pl camera1_phiX_Read1_r camera1_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera2_phiX_Read1_r camera2_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera3_phiX_Read1_r camera3_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera4_phiX_Read1_r camera4_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera5_phiX_Read1_r camera5_phiX_Read1_r_no_indel");
	system("./filter_indel.pl camera6_phiX_Read1_r camera6_phiX_Read1_r_no_indel");

#mismatch counting
	system("./mismatch_count_v4.pl camera1_phiX_Read1_f camera1_phiX_Read1_r camera1_Read1_mm size_r1_c1");
	system("./mismatch_count_v4.pl camera2_phiX_Read1_f camera2_phiX_Read1_r camera2_Read1_mm size_r1_c2");
	system("./mismatch_count_v4.pl camera3_phiX_Read1_f camera3_phiX_Read1_r camera3_Read1_mm size_r1_c3");
	system("./mismatch_count_v4.pl camera4_phiX_Read1_f camera4_phiX_Read1_r camera4_Read1_mm size_r1_c4");
	system("./mismatch_count_v4.pl camera5_phiX_Read1_f camera5_phiX_Read1_r camera5_Read1_mm size_r1_c5");
	system("./mismatch_count_v4.pl camera6_phiX_Read1_f camera6_phiX_Read1_r camera6_Read1_mm size_r1_c6");

	system("cat header camera1_Read1_mm >camera1_mmh");
	system("cat header camera2_Read1_mm >camera2_mmh");
	system("cat header camera3_Read1_mm >camera3_mmh");
	system("cat header camera4_Read1_mm >camera4_mmh");
	system("cat header camera5_Read1_mm >camera5_mmh");
	system("cat header camera6_Read1_mm >camera6_mmh");

#plotting
	system("R --slave --vanilla <plot.r");
}



##########################################
##########################################
#paired end Miseq sequencing
elsif ($ARGV[0] eq "miseq_paired_end") {
#retrieve the first 30bp of the sequencing reads and align them
	system("fastx_trimmer -l 30 -i $ARGV[1] -Q33 >read1.fq");
	system("fastx_trimmer -l 30 -i $ARGV[2] -Q33 >read2.fq");
	system("bowtie2 -x ../phiX -1 read1.fq -2 read2.fq -S align.sam");

#seperate phiX reas with no indels in the first 30 bp
	system("./MD.pl align.sam T8_tmp.sam");


#seperate forward reads from reverse reads
	system("head -2 align.sam >sam_header");
	system("cat sam_header T8_tmp.sam >T8.sam");
	system("samtools view -f 0x40 -S T8.sam >Read1.sam");
	system("cat sam_header Read1.sam >Read1_h.sam");
	system("samtools view -F 0x10 -S Read1_h.sam >phiX_Read1_f.sam");
	system("samtools view -f 0x10 -S Read1_h.sam >phiX_Read1_r.sam");
	system("samtools view -f 0x80 -S T8.sam >Read2.sam");
	system("cat sam_header Read2.sam >Read2_h.sam");
	system("samtools view -F 0x10 -S Read2_h.sam >phiX_Read2_f.sam");
	system("samtools view -f 0x10 -S Read2_h.sam >phiX_Read2_r.sam");

#making sequence file of forward/reverse reads
	system("./mk_fa1.pl $ARGV[1] phiX_Read1_f.sam phiX_Read1_f_seq");
	system("./mk_fa1r.pl $ARGV[1] phiX_Read1_r.sam phiX_Read1_r_seq");
	system("./mk_fa2.pl $ARGV[2] phiX_Read2_f.sam phiX_Read2_f_seq");
	system("./mk_fa2r.pl $ARGV[2] phiX_Read2_r.sam phiX_Read2_r_seq");

#making bed file to retrieve reference sequence
	system("./bed.pl phiX_Read1_f_seq phiX_Read1_f.sam phiX_Read1_f.bed");
	system("./bed_r.pl phiX_Read1_r_seq phiX_Read1_r.sam phiX_Read1_r.bed");
	system("./bed.pl phiX_Read2_f_seq phiX_Read2_f.sam phiX_Read2_f.bed");
	system("./bed_r.pl phiX_Read2_r_seq phiX_Read2_r.sam phiX_Read2_r.bed");

#get reference fasta files from bed
	system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_f.bed -fo phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_r.bed -fo phiX_Read1_r_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read2_f.bed -fo phiX_Read2_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read2_r.bed -fo phiX_Read2_r_ref.fa -name");

#format reference fasta file to table file for merging with real sequencing data in next steps
	system("./format.pl phiX_Read1_f_ref.fa phiX_Read1_f_ref");
	system("./format.pl phiX_Read1_r_ref.fa phiX_Read1_r_ref");
	system("./format.pl phiX_Read2_f_ref.fa phiX_Read2_f_ref");
	system("./format.pl phiX_Read2_r_ref.fa phiX_Read2_r_ref");

#merging reference seq table with real sequencing data in next steps
	system("./overlaphash.pl phiX_Read1_f_ref phiX_Read1_f_seq phiX_Read1_f");
	system("./overlaphash_r.pl phiX_Read1_r_ref phiX_Read1_r_seq phiX_Read1_r");
	system("./overlaphash.pl phiX_Read2_f_ref phiX_Read2_f_seq phiX_Read2_f");
	system("./overlaphash_r.pl phiX_Read2_r_ref phiX_Read2_r_seq phiX_Read2_r");

#filter away sequences with indels defined as 3 continuous nt mismatching between ref and seq
	system("./filter_indel.pl phiX_Read1_f phiX_Read1_f_no_indel");
	system("./filter_indel.pl phiX_Read1_r phiX_Read1_r_no_indel");
	system("./filter_indel.pl phiX_Read2_f phiX_Read2_f_no_indel");
	system("./filter_indel.pl phiX_Read2_r phiX_Read2_r_no_indel");

#mismatch counting
	system("./mismatch_count_v4.pl phiX_Read1_f phiX_Read1_r Read1_mm size_r1");
	system("./mismatch_count_v4_r2.pl phiX_Read2_f phiX_Read2_r size_r1 Read2_mm");
	system("cat header Read1_mm Read2_mm  >mmh");

#plotting
	system("R --slave --vanilla <plot_miseq.r");
}

#single end Miseq sequencing
elsif ($ARGV[0] eq "miseq_single_end") {
#retrieve the first 30bp of the sequencing reads and align them
        system("fastx_trimmer -l 30 -i $ARGV[1] -Q33 >read1.fq");
        system("bowtie2 -x ../phiX -U read1.fq -S align.sam");

#seperate phiX reas with no indels in the first 30 bp
	system("./MD.pl align.sam tmp.sam");

#seperate forward reads from reverse reads
	system("head -2 align.sam >sam_header");
	system("cat sam_header tmp.sam >Read1_h.sam");
	system("samtools view -F 0x10 -S Read1_h.sam >phiX_Read1_f.sam");
	system("samtools view -f 0x10 -S Read1_h.sam >phiX_Read1_r.sam");

#making sequence file of Phix forward/reverse reads
	system("./mk_fa.pl $ARGV[1] phiX_Read1_f.sam phiX_Read1_f_seq");
	system("./mk_far.pl $ARGV[1] phiX_Read1_r.sam phiX_Read1_r_seq");

#making bed file to retrieve reference sequence
	system("./bed_s.pl phiX_Read1_f_seq phiX_Read1_f.sam phiX_Read1_f.bed");
	system("./bed_rs.pl phiX_Read1_r_seq phiX_Read1_r.sam phiX_Read1_r.bed");

#get reference fasta files from bed
	system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_f.bed -fo phiX_Read1_f_ref.fa -name");
	system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_r.bed -fo phiX_Read1_r_ref.fa -name");

#format reference fasta file to table file for merging with real sequencing data in next steps
	system("./format.pl phiX_Read1_f_ref.fa phiX_Read1_f_ref");
	system("./format.pl phiX_Read1_r_ref.fa phiX_Read1_r_ref");

#merging reference seq table with real sequencing data in next steps
	system("./overlaphash_s.pl phiX_Read1_f_ref phiX_Read1_f_seq phiX_Read1_f");
	system("./overlaphash_rs.pl phiX_Read1_r_ref phiX_Read1_r_seq phiX_Read1_r");

#filter away sequences with indels defined as 3 continuous nt mismatching between ref and seq
	system("./filter_indel.pl phiX_Read1_f phiX_Read1_f_no_indel");
	system("./filter_indel.pl phiX_Read1_r phiX_Read1_r_no_indel");

#mismatch counting
	system("./mismatch_count_v4.pl phiX_Read1_f phiX_Read1_r Read1_mm size_r1_c1");
	system("cat header Read1_mm >mmh");

#plotting
	system("R --slave --vanilla <plot_miseq.r");
}

############################################################
############################################################
#paired end HiSeq sequencing
elsif ($ARGV[0] eq "hiseq_paired_end") {
# downsample
	$n=-1;
	while (@ARGV) {
		$param = shift;
		$n=$n+1;
		if ($n>0){
        		$r1=`grep -c '.*' $param`;
        		if ($r1>5500000) {
                		$s=int($r1/44);
                		for ($j=1;$j<=10;$j++) {
                        		$start=$s*4*$j+400000;
                        		$cmd="head -$start $param|tail -400000>>int$n.fq";
					system($cmd);
				}

                	}
        		else{
                		$cmd="head -4000000 $param>int$n.fq";
				system($cmd);
        		}
		}
	}


#loop through each lane and perform the related tasks
	for ($i=1;$i<=$n;$i=$i+2) {
		$j=$i+1;
		$k=$j/2;

#retrieve the first 30bp of the sequencing reads and align them
		$cmd="fastx_trimmer -l 30 -i int$i.fq -Q33 >read1.fq";
		system($cmd);
		$cmd="fastx_trimmer -l 30 -i int$j.fq -Q33 >read2.fq";
		system($cmd);
		$cmd="bowtie2 -x ../phiX -1 read1.fq -2 read2.fq -S L$k.sam";
		system($cmd);

#seperate phiX reas with no indels in the first 30 bp
		$cmd="./MD.pl L$k.sam tmp.sam";
		system($cmd);

#seperate forward reads from reverse reads
		$cmd="head -2 L$k.sam >sam_header";
		system($cmd);
		system("cat sam_header tmp.sam >T8.sam");
		system("samtools view -f 0x40 -S T8.sam >Read1.sam");
		system("cat sam_header Read1.sam >Read1_h.sam");
		system("samtools view -F 0x10 -S Read1_h.sam >phiX_Read1_f.sam");
		system("samtools view -f 0x10 -S Read1_h.sam >phiX_Read1_r.sam");
		system("samtools view -f 0x80 -S T8.sam >Read2.sam");
		system("cat sam_header Read2.sam >Read2_h.sam");
		system("samtools view -F 0x10 -S Read2_h.sam >phiX_Read2_f.sam");
		system("samtools view -f 0x10 -S Read2_h.sam >phiX_Read2_r.sam");

#making sequence file of forward/reverse reads
		$cmd="./mk_fa1.pl int$i.fq phiX_Read1_f.sam phiX_Read1_f_seq";
		system($cmd);
		$cmd="./mk_fa1r.pl int$i.fq phiX_Read1_r.sam phiX_Read1_r_seq";
		system($cmd);
		$cmd="./mk_fa2.pl int$j.fq phiX_Read2_f.sam phiX_Read2_f_seq";
		system($cmd);
		$cmd="./mk_fa2r.pl int$j.fq phiX_Read2_r.sam phiX_Read2_r_seq";
		system($cmd);

#making bed file to retrieve reference sequence
		system("./bed.pl phiX_Read1_f_seq phiX_Read1_f.sam phiX_Read1_f.bed");
		system("./bed_r.pl phiX_Read1_r_seq phiX_Read1_r.sam phiX_Read1_r.bed");
		system("./bed.pl phiX_Read2_f_seq phiX_Read2_f.sam phiX_Read2_f.bed");
		system("./bed_r.pl phiX_Read2_r_seq phiX_Read2_r.sam phiX_Read2_r.bed");

#get reference fasta files from bed
		system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_f.bed -fo phiX_Read1_f_ref.fa -name");
		system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_r.bed -fo phiX_Read1_r_ref.fa -name");
		system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read2_f.bed -fo phiX_Read2_f_ref.fa -name");
		system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read2_r.bed -fo phiX_Read2_r_ref.fa -name");

#format reference fasta file to table file for merging with real sequencing data in next steps
		system("./format.pl phiX_Read1_f_ref.fa phiX_Read1_f_ref");
		system("./format.pl phiX_Read1_r_ref.fa phiX_Read1_r_ref");
		system("./format.pl phiX_Read2_f_ref.fa phiX_Read2_f_ref");
		system("./format.pl phiX_Read2_r_ref.fa phiX_Read2_r_ref");

#merging reference seq table with real sequencing data in next steps
		system("./overlaphash.pl phiX_Read1_f_ref phiX_Read1_f_seq phiX_Read1_f");
		system("./overlaphash_r.pl phiX_Read1_r_ref phiX_Read1_r_seq phiX_Read1_r");
		system("./overlaphash.pl phiX_Read2_f_ref phiX_Read2_f_seq phiX_Read2_f");
		system("./overlaphash_r.pl phiX_Read2_r_ref phiX_Read2_r_seq phiX_Read2_r");

#filter away sequences with indels defined as 3 continuous nt mismatching between ref and seq
		system("./filter_indel.pl phiX_Read1_f phiX_Read1_f_no_indel");
		system("./filter_indel.pl phiX_Read1_r phiX_Read1_r_no_indel");
		system("./filter_indel.pl phiX_Read2_f phiX_Read2_f_no_indel");
		system("./filter_indel.pl phiX_Read2_r phiX_Read2_r_no_indel");

#mismatch counting
		system("./mismatch_count_v4.pl phiX_Read1_f phiX_Read1_r Read1_mm size_r1");
		system("./mismatch_count_v4_r2.pl phiX_Read2_f phiX_Read2_r size_r1 Read2_mm");

		$cmd="cat header Read1_mm Read2_mm  >L$k\_mmh";
		system($cmd);

		$s=`ls -al L$k\_mmh|cut -f5 -d " "`;

		if($s==19) {
        		$cmd="rm L$k\_mmh";
			system($cmd);
		}
	}

#plotting
	system("Rscript plot_hiseq.r `ls *mmh|sort`");
}


############################################################
############################################################
#single end HiSeq sequencing
elsif ($ARGV[0] eq "hiseq_single_end") {
# downsample
        $n=-1;
        while (@ARGV) {
                $param = shift;
                $n=$n+1;
                if ($n>0){
                        $r1=`grep -c '.*' $param`;
                        if ($r1>5500000) {
                                $s=int($r1/44);
                                for ($j=1;$j<=10;$j++) {
                                        $start=$s*4*$j+400000;
                                        $cmd="head -$start $param|tail -400000>>int$n.fq";
                                        system($cmd);
                                }

                        }
                        else{
                                $cmd="head -4000000 $param>int$n.fq";
                                system($cmd);
                        }
                }
        }

#loop through each lane and perform the related tasks
        for ($i=1;$i<=$n;$i=$i+1) {
#retrieve the first 30bp of the sequencing reads and align them
		$cmd="fastx_trimmer -l 30 -i int$i.fq -Q33 >read1.fq";
		system($cmd);
		$cmd="bowtie2 -x ../phiX -U read1.fq -S L$i.sam";
		system($cmd);
#seperate phiX reas with no indels in the first 30 bp
		$cmd="./MD.pl L$i.sam tmp.sam";
		system($cmd);

#seperate forward reads from reverse reads
		$cmd="head -2 L$i.sam >sam_header";
		system($cmd);
		system("cat sam_header tmp.sam >Read1_h.sam");
		system("samtools view -F 0x10 -S Read1_h.sam >phiX_Read1_f.sam");
		system("samtools view -f 0x10 -S Read1_h.sam >phiX_Read1_r.sam");

#making sequence file of Phix forward/reverse reads
		$cmd="./mk_fa.pl int$i.fq phiX_Read1_f.sam phiX_Read1_f_seq";
		system($cmd);
		$cmd="./mk_far.pl int$i.fq phiX_Read1_r.sam phiX_Read1_r_seq";
		system($cmd);
#making bed file to retrieve reference sequence
		system("./bed_s.pl phiX_Read1_f_seq phiX_Read1_f.sam phiX_Read1_f.bed");
		system("./bed_rs.pl phiX_Read1_r_seq phiX_Read1_r.sam phiX_Read1_r.bed");
#get reference fasta files from bed
		system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_f.bed -fo phiX_Read1_f_ref.fa -name");
		system("bedtools getfasta -fi ../phiX.fa -bed phiX_Read1_r.bed -fo phiX_Read1_r_ref.fa -name");

#format reference fasta file to table file for merging with real sequencing data in next steps
		system("./format.pl phiX_Read1_f_ref.fa phiX_Read1_f_ref");
		system("./format.pl phiX_Read1_r_ref.fa phiX_Read1_r_ref");

#merging reference seq table with real sequencing data in next steps
		system("./overlaphash_s.pl phiX_Read1_f_ref phiX_Read1_f_seq phiX_Read1_f");
		system("./overlaphash_rs.pl phiX_Read1_r_ref phiX_Read1_r_seq phiX_Read1_r");

#filter away sequences with indels defined as 3 continuous nt mismatching between ref and seq
		system("./filter_indel.pl phiX_Read1_f phiX_Read1_f_no_indel");
		system("./filter_indel.pl phiX_Read1_r phiX_Read1_r_no_indel");

#mismatch counting
		system("./mismatch_count_v4.pl phiX_Read1_f phiX_Read1_r Read1_mm size_r1_c1");

		$cmd="cat header Read1_mm >L$i\_mmh";
		system($cmd);

		$s=`ls -al L$i\_mmh|cut -f5 -d " "`;

		if($s==19){
        		$cmd="rm L$i\_mmh";
			system($cmd);
		}
	}
#plotting
	$cmd="Rscript plot_hiseq.r `ls *mmh|sort`";
	system($cmd);
}
$jpg=$datef."\.jpg";
system("cp *jpg ../$jpg");
chdir '../';
system("rm -rf $datef");



